// Example/Template of a logger

'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SimpleLogger = function () {
  function SimpleLogger() {
    _classCallCheck(this, SimpleLogger);

    this.messages = [];
    this.runName = "";
  }

  _createClass(SimpleLogger, [{
    key: "warn",
    value: function warn(message) {
      var suppressDuplicateMessages = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (suppressDuplicateMessages !== false && this.messages.indexOf(message) !== -1) return;

      var sentMessage = this.runName + ": " + message;
      // Log the message to the JS Console
      console.log(sentMessage);

      // Some custom code to send a message to external systems, like:
      // Slack, Discord, HipChat, etc.

      // Add message to history
      this.messages.push(message);
    }
  }]);

  return SimpleLogger;
}();

module.exports.SimpleLogger = SimpleLogger;